<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_HotelCategory ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_HotelCategory extends AbstractStructArrayBase
{
    /**
     * The HotelCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_HotelCategory[]
     */
    public $HotelCategory;
    /**
     * Constructor method for ArrayOfJP_HotelCategory
     * @uses ArrayOfJP_HotelCategory::setHotelCategory()
     * @param \StructType\JP_HotelCategory[] $hotelCategory
     */
    public function __construct(array $hotelCategory = array())
    {
        $this
            ->setHotelCategory($hotelCategory);
    }
    /**
     * Get HotelCategory value
     * @return \StructType\JP_HotelCategory[]|null
     */
    public function getHotelCategory()
    {
        return $this->HotelCategory;
    }
    /**
     * This method is responsible for validating the values passed to the setHotelCategory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelCategory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHotelCategoryForArrayConstraintsFromSetHotelCategory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_HotelCategoryHotelCategoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_HotelCategoryHotelCategoryItem instanceof \StructType\JP_HotelCategory) {
                $invalidValues[] = is_object($arrayOfJP_HotelCategoryHotelCategoryItem) ? get_class($arrayOfJP_HotelCategoryHotelCategoryItem) : sprintf('%s(%s)', gettype($arrayOfJP_HotelCategoryHotelCategoryItem), var_export($arrayOfJP_HotelCategoryHotelCategoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HotelCategory property can only contain items of type \StructType\JP_HotelCategory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HotelCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelCategory[] $hotelCategory
     * @return \ArrayType\ArrayOfJP_HotelCategory
     */
    public function setHotelCategory(array $hotelCategory = array())
    {
        // validation for constraint: array
        if ('' !== ($hotelCategoryArrayErrorMessage = self::validateHotelCategoryForArrayConstraintsFromSetHotelCategory($hotelCategory))) {
            throw new \InvalidArgumentException($hotelCategoryArrayErrorMessage, __LINE__);
        }
        $this->HotelCategory = $hotelCategory;
        return $this;
    }
    /**
     * Add item to HotelCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelCategory $item
     * @return \ArrayType\ArrayOfJP_HotelCategory
     */
    public function addToHotelCategory(\StructType\JP_HotelCategory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_HotelCategory) {
            throw new \InvalidArgumentException(sprintf('The HotelCategory property can only contain items of type \StructType\JP_HotelCategory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HotelCategory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_HotelCategory|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_HotelCategory|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_HotelCategory|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_HotelCategory|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_HotelCategory|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelCategory
     */
    public function getAttributeName()
    {
        return 'HotelCategory';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_HotelCategory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
